/************************************************************************
*									*
*   Copyright 1988, 1989, 1990, Brown University, Providence, RI.	*
*   Permission to use, copy, modify and distribute this software and	*
*   its documentation for any purpose other than its incorporation	*
*   into a commercial product, is hereby granted, provided that this	*
*   copyright notice appears on all copies and the distribution is	*
*   only within the organization represented by the person receiving	*
*   the software from Brown.  Brown requests notification of the of	*
*   any important modifications to this software or its documentation.	*
*									*
************************************************************************/
/************************************************************************
*									*
*   error.c								*
*									*
************************************************************************/
#include <stdio.h>

static int print = 1;

/************************************************************************
*									*
*   errors								*
*									*
*	Turn non-fatal error printing on or off.			*
*									*
************************************************************************/
void
errors(on)
   int on;
{
   print = on;
}

/*VARARGS*/
void
warn(fstring, a1, a2, a3, a4, a5, a6, a7, a8, a9)
   char *fstring;
   int a1, a2, a3, a4, a5, a6, a7, a8, a9;
{
   if (print) fprintf(stderr, fstring, a1, a2, a3, a4, a5, a6, a7, a8, a9);
}

/*VARARGS*/
void
quit(code, fstring, a1, a2, a3, a4, a5, a6, a7, a8, a9)
   int code;
   char *fstring;
   int a1, a2, a3, a4, a5, a6, a7, a8, a9;
{
   fprintf(stderr, fstring, a1, a2, a3, a4, a5, a6, a7, a8, a9);
   exit(code);
}

/*VARARGS*/
int
err(code, fstring, a1, a2, a3, a4, a5, a6, a7, a8, a9)
   int code;
   char *fstring;
   int a1, a2, a3, a4, a5, a6, a7, a8, a9;
{
   if (print) fprintf(stderr, fstring, a1, a2, a3, a4, a5, a6, a7, a8, a9);
   return code;
}

void
pquit(code, msg)
   int code;
   char *msg;
{
   perror(msg);
   exit(code);
}

int
perr(code, msg)
   int code;
   char *msg;
{
   perror(msg);
   return code;
}
