/************************************************************************
*									*
*   Copyright 1988, 1989, 1990, Brown University, Providence, RI.	*
*   Permission to use, copy, modify and distribute this software and	*
*   its documentation for any purpose other than its incorporation	*
*   into a commercial product, is hereby granted, provided that this	*
*   copyright notice appears on all copies and the distribution is	*
*   only within the organization represented by the person receiving	*
*   the software from Brown.  Brown requests notification of the of	*
*   any important modifications to this software or its documentation.	*
*									*
************************************************************************/
/************************************************************************
*									*
*   resource.h								*
*									*
*	Types for resource model.					*
*									*
************************************************************************/

#define	MAPPED			0x1	/* mapped? */
#define	SUBSTRUCTURE_REDIRECT	0x2	/* selected for substructure redirect?*/
#define	OVERRIDE_REDIRECT	0x4	/* override redirect bit set? */
#define	RESIZE_REDIRECT		0x8	/* selected for resize redirect? */

typedef enum {
	FONT,
	PIXMAP,
	GC,
	CMAP,
	CURSOR
}rtype_t;

typedef struct _resource_t {
   rtype_t type;			/* type of resource (eg Font) */
   rid_t rid;				/* resource id */
   struct _resource_t  *next;
}resource_t;

typedef struct _clientstate_t {
   struct _window_t *root;
   int closedownmode;
   resource_t *resources;		/* list of non-window resources */
}clientstate_t;

typedef struct _saveset_t {
   clientstate_t *client;
   struct _saveset_t *next;
}saveset_t;

				/* note: flags and (substr_c & resize_c) */
				/* 	are redundant.			 */
typedef struct _window_t {
   rid_t rid;				/* window id */
   int flags;				/* mapped, redirect? */
   short x, y;				/* upper left corner in root coords */
   struct _window_t *parent;		/* parent, zero if root */
   struct _window_t *prevsib;		/* left sibling */
   struct _window_t *nextsib;		/* right sibling */
   struct _window_t *child;		/* first child */
   clientstate_t *client;		/* client we belong to */
   clientstate_t *resize_c;		/* client selected resize redirect */
   clientstate_t *substr_c;		/* client selected substr redirect */
   saveset_t *saveset;			/* clients of savesets we're in */
}window_t;
